var firstButton;
var secondButton;

var clearTrack = 0;
var select = 0;

var mute = false;
var score = 0;
var level = 1;
var timeLeft = true;
var printOnce1 = true;
var printOnce2 = true;
var clicked = false;
var trackTime = 0.5;
var canClick = true;

var forcedMatchReset2 = false;
var showingHint = false;
var stopTimer = false;
var pausedButtonActive = false;
var comboAnimating = false;
var scoreAnimating = false;
var firstPlayCheck = false;
var highlightColor = '#FFFF00';
var opacityShift = 30;
var highlightSize = 1;
var edgeOfBoard = false;
var addToTimerBoolean = true;
var animateThreads = 0;
var pulseHint;
var timerColor = [255, 255, 0];

var changeTimerColor = false;
var changeColorCounter = 0;
var touchPositions = [];
var disableScolling = false;
var trophyIndex = 0;

var mainVolume = .1;

/**
 * A promise wrapper for requestAnimationFrame.
 * @returns {Promise} Resolves when requestAnimationFrame calls back
 */
 function promiseRAF() {
 	return new Promise(function (resolve, reject) {
 		requestAnimationFrame(resolve);
 	});
 }

 var start = true;
 var loop = 0;
 var firstSelect = false;
 var paused = true;
 var top = 180;
 var timeScale = 0.5;
 var swapBack = false;
 var updateMassMoveBalls = false;
 var loop2 = 0;
 var waitForSwapBack = false;

 var newLevel = false;
 var startup = true;
 var touchedBall = false;
 var multiMatchAnimating = false;
 var lastTouch = null;

 var alreadyStarted = false;

 document.addEventListener("DOMContentLoaded", function(){
  // Handler when the DOM is fully loaded
  
  var imagesLoaded = document.getElementById("mainMenu").complete;
  if(imagesLoaded){
  	setTimeout(function(){
  		document.getElementById("progressBar").style.display = "none";
  		document.getElementById("mainWrap").style.opacity = "1";
  	}, 500);
  	

  }else{
  	setTimeout(function(){
  		document.getElementById("progressBar").style.display = "none";
  		document.getElementById("mainWrap").style.opacity = "1";
  	}, 1500);
  	
  }

});

function resetGame(){
 	start = false;
 	paused = false;
 	timeScale = 0.5;
 	startup = true;
	if(marshTimer){
 		var fadeTarget1 = document.getElementById(lizardTimer);
 		var fadeTarget2 = document.getElementById(marshTimer);
		fadeOutEffect(fadeTarget1, 1, 1, 50);
		fadeOutEffect(fadeTarget1, 1, 1, 50);
		setTimeout(function(){
			stopAnimate(marshTimer);
 			stopAnimate(lizardTimer);
		}, 300);
 	}
 	newGame1();
 	setTimeout(function(){
		minimapAspectX = document.getElementById("minimap").getBoundingClientRect().width / document.getElementById("leftSideImage").width;
		minimapAspectY = document.getElementById("minimap").getBoundingClientRect().height / document.getElementById("leftSideImage").height;
		document.getElementById('minmapHighlight').style.left = Math.abs(document.getElementById("leftSideImage").offsetLeft * minimapAspectX)  + "px";
		document.getElementById('minmapHighlight').style.top = Math.abs(document.getElementById("leftSideImage").offsetTop * minimapAspectY)  + "px";
		document.getElementById('minimapHighlightImage').style.left = (document.getElementById("leftSideImage").offsetLeft * minimapAspectX)  + "px";
		document.getElementById('minimapHighlightImage').style.top = (document.getElementById("leftSideImage").offsetTop * minimapAspectY)  + "px";
	}, 800);
 	
 	if(!newLevel){
 		score = 0;
 		timeScale = 0.5;
 		//document.getElementById("level").innerHTML = "Level: " + level;
 		//document.getElementById("score").innerHTML = "Score: " + score;
 		mainTheme = document.getElementById("maintheme").play();
 		level = 1;
 		setTimeout(function(){
 			startup = false;

 		}, 500);

 	}else{
 		newLevel = false;
 		document.getElementById("level").innerHTML = "Level: " + level;
 	}
 	var fadeTarget = document.getElementById("gameOverScreen");
 	fadeOutEffect(fadeTarget, -1, -1, 30);
 	newRound();
 	document.getElementById("mainGame").style.display = 'none';
 	document.getElementById("mainGame").style.opacity = 0;
 	document.getElementById("mainGame").style.animationName = 'none';
 	setTimeout(function(){
 		
 		document.getElementById('mainMenu').style.display = 'none';
 		//document.getElementById('mainGame').style.display = 'block';
 		var fadeTarget2 = document.getElementById("mainGame");
 		fadeInEffect(fadeTarget2, -1, -1, 70);
 		
 		//document.getElementById('gameOverScreen').style.display = 'none';
 	}, 750);
 } 

 function firstPlay(){
 	if(alreadyStarted){
 		return;
 	}

 	alreadyStarted = true;
 	document.getElementById("foundSound").play();
 	document.getElementById("foundSound").pause();
 	document.getElementById("badSound").play();
 	document.getElementById("badSound").pause();
 	var mainTheme = document.getElementById("maintheme");
 	maintheme.volume = mainVolume;
 	maintheme.play();
 	maintheme.loop = true;
 	firstPlayCheck = true;
 	var fadeTarget = document.getElementById("mainMenu");
 	var fadeTarget1 = document.getElementById("play");
 	var fadeTarget2 = document.getElementById("howToPlay");
 	fadeTarget.style.animationName = 'fadeOutAnimation';
 	fadeTarget1.style.animationName = 'fadeOutAnimation';
 	fadeTarget2.style.animationName = 'fadeOutAnimation';
 	//fadeOutEffect(fadeTarget, -1, -1, 60);
 	//fadeOutEffect(fadeTarget1, -1, -1, 60);
 	//fadeOutEffect(fadeTarget2, -1, -1, 60);
 	setTimeout(changeScreen,700);
 	setTimeout(function(){
 		startup = false;
 		score = 0;
 		newRound();
 		//document.getElementById("score").innerHTML = "Score: " + score;
 	},600);




 }
 function changeScreen(){
 	if(start){
 		if(timeLeft == false){
 			timeLeft = true;
 			document.getElementById('gameOverScreen').style.display = 'none';
 		}
 		document.getElementById('mainMenu').style.display = 'none';
 		document.getElementById('mainGame').style.display = 'block';
		//doDebug();
		start = false;
		paused = false;

	}else{
		//document.getElementById('mainMenu').style.display = 'block';
		//document.getElementById('mainGame').style.display = 'none';
		if(timeLeft == false){
			var fadeTarget = document.getElementById("mainGame");
			var fadeTarget1 = document.getElementById("mainMenu");
			//fadeOutEffect(fadeTarget, -1, -1, 50);
			//fadeOutEffect(fadeTarget1, -1, -1, 50);
			fadeTarget.style.animationName = 'fadeOutAnimation';
			fadeTarget1.style.animationName = 'fadeOutAnimation';
			//document.getElementById('mainGame').style.display = 'none';
			//document.getElementById('mainMenu').style.display = 'none';
			//document.getElementById('gameOverScreen').style.display = 'block';
			setTimeout(function(){
				document.getElementById("mainGame").style.display = 'none';
				document.getElementById("mainMenu").style.display = 'none';

				var fadeTarget2 = document.getElementById("gameOverScreen");
				fadeInEffect(fadeTarget2, -1, -1, 50);
			}, 700);
			

			//document.getElementById("gameOverScoreBoard").innerHTML = "You Scored: " + score;
			//document.getElementById("gameOverScoreBoard1").innerHTML = "Your Level: " + level;
			//document.getElementById("maxChain").innerHTML = "Longest Chain: " + maxChainCount;
			level = 1;
			return;
			
		}

		start = true;
	}
}


function mute1(){
	if(mute){
		mute = false;
		//document.getElementById("mute").style.opacity = 1;
		document.getElementById("mute").querySelector("img").src = "Assets/" + gameType + "/muteButton.png";
		
		document.activeElement.blur();
		document.getElementById("maintheme").play();
		document.getElementById("maintheme").muted = false;
		document.getElementById("foundSound").muted = false;
		document.getElementById("badSound").muted = false;
		
	}else{
		mute = true;
		//document.getElementById("mute").style.opacity = 0.5;
		document.activeElement.blur();
		document.getElementById("mute").querySelector("img").src = "Assets/" + gameType + "/muted.png";
		document.getElementById("maintheme").muted = true;
		document.getElementById("foundSound").muted = true;
		document.getElementById("badSound").muted = true;
		document.getElementById("maintheme").pause();
	}
}


function pauseGame(){
	if(pausedButtonActive){
		document.getElementById("pauseGameOverlay").style.display = "none";
		//document.getElementById("preventInputGame").style.display = "none";
		document.getElementById("pauseButtonText").innerHTML = "&#9612;&#9612;";
		pausedButtonActive = false;
	}else{
		pausedButtonActive = true;
		document.getElementById("pauseGameOverlay").style.display = "flex";
		selectBalls = [];
		//document.getElementById("preventInputGame").style.display = "block";
		//document.getElementById("pauseButtonText").fontSize = "40pt !important";
		document.getElementById("pauseButtonText").innerHTML = "&#9658;";

		

	}

}
//timeScale = .95;

function rgb2hex2(red, green, blue) {
	var rgb = blue | (green << 8) | (red << 16);
	return '#' + (0x1000000 + rgb).toString(16).slice(1)
}

function newLevelReached(){

	levelCompleteAnimation();

	setTimeout(function(){
		startup = false;
		newLevel = false;
		
	}, 3200);
	return;
}

function startNewLevel(){
	

	if(level >= 3){
		timeLeft = false;
		loseGameAnimation();
		setTimeout(function(){
			changeScreen();
		}, 250);
		return;
	}
	level++;
	newLevelAnimation();

	setTimeout(newRound, 350);

	return;
	var fadeOutTarget1 = document.getElementById("midLevelScoreboardChain");	
	var fadeOutTarget2 = document.getElementById("midLevelScoreboardTitle");	
	var fadeOutTarget3 = document.getElementById("midLevelScoreboardLevel");	
	var fadeOutTarget4 = document.getElementById("midLevelScoreboardScore");
	var fadeOutTarget5 = document.getElementById("nextLevel");	
	var fadeOutTarget6 = document.getElementById("midLevelScoreboard");	
	var fadeOutTarget7 = document.getElementById("midLevelBackgroundChange");	

	var fadeTarget3 = document.getElementById("rightSideGameBoard");



	fadeOutEffect(fadeOutTarget1, -1, -1, 50);
	fadeOutEffect(fadeOutTarget2, -1, -1, 50);
	fadeOutEffect(fadeOutTarget3, -1, -1, 50);
	fadeOutEffect(fadeOutTarget4, -1, -1, 50);
	fadeOutEffect(fadeOutTarget5, -1, -1, 50);
	fadeOutEffect(fadeOutTarget6, -1, -1, 50);



	newLevel = true;
	level++;
	timeScale = 0.6;
	//resetGame();
	//document.getElementById("level").innerHTML = "Level: " + level;
	document.getElementById("midLevelScoreboard").style.visibility = "hidden";


	setTimeout(function(){
		document.getElementById("canvasBlock").style.transform = 'scaleY(1)';
		document.getElementById("canvasBlock").style.top = '0%';
		//document.getElementById("mainGame").classList.remove("mainGameBackground");
		setTimeout(function(){
		//document.getElementById("midLevelBackgroundChange").style.opacity = 0;
		fadeOutEffect(fadeOutTarget7, -1, -1, 50);


	}, 50);



		fadeInEffect(fadeTarget1, -1, -1, 50);
		fadeInEffect(fadeTarget2, -1, -1, 50);
		fadeInEffect(fadeTarget3, -1, -1, 50);
		fadeInEffect(fadeTarget4, -1, -1, 50);

		setTimeout(function(){
			startup = false;
			newLevel = false;
		}, 500);
		return;
		setTimeout(function(){
			var scaleY = 100;

			return;
			var expandTarget = setInterval(function () {
				if (scaleY > 0) {
					scaleY+= (100 - scaleY )/5;  
			}else{
				clearInterval(expandTarget);
			}
		}, 50);
		}, 200);
	}, 500);

}

function newGame1(){
	timeLeft = true;
	newRound();

	if(!newLevel){
		score = 0;
		chainCount = 0;
		maxChainCount = 0;
	}else{
		
		chainCount = 0;
	}

}

function addScore(){
		if(!document.getElementById("foundSound").playing){
			if(!mute){
				document.getElementById("foundSound").pause();
				document.getElementById("foundSound").currentTime = 0.1;
				document.getElementById("foundSound").play();	
			}
		}else{
			if(!mute){
				document.getElementById("foundSound").pause();
				document.getElementById("foundSound").currentTime = 0.1;
				document.getElementById("foundSound").play();
			}
			
		}
	}

function badClick(){
		if(!document.getElementById("badSound").playing){
			if(!mute){
				document.getElementById("badSound").pause();
				document.getElementById("badSound").currentTime = 0.1;
				document.getElementById("badSound").play();	
			}
		}else{
			if(!mute){
				document.getElementById("badSound").pause();
				document.getElementById("badSound").currentTime = 0.1;
				document.getElementById("badSound").play();
			}
			
		}
	}
	function showHelp(){
		if(!firstPlayCheck){
			
			var fadeTarget = document.getElementById("mainMenu");
			fadeOutEffect(fadeTarget, -1, -1, 50);
			setTimeout(function(){
				var fadeTarget2 = document.getElementById("waitState");
				fadeInEffect(fadeTarget2, -1, -1, 50);
				//document.getElementById('mainGame').style.display = 'block';
				document.getElementById("information").style.display = "block";
				document.getElementById("play1").style.display = "block";
				paused = true;
			}, 500);
			return;
		}
		

		//document.getElementById('mainMenu').style.display = 'none';
		var fadeTarget2 = document.getElementById("waitState");
		fadeInEffect(fadeTarget2, -1, -1, 50);


		//document.getElementById("waitState").style.display = "block";
		document.getElementById("information").style.display = "block";
		document.getElementById("play1").style.display = "block";
		paused = true;
		document.getElementById('mainGame').style.display = 'block';
		
		return;
	}

	function returnPlay(){
		paused = false;
		//changeScreen();
		//document.getElementById("mainGame").classList.remove("mainGameBackground");
		var fadeTarget = document.getElementById("waitState");
		fadeOutEffect(fadeTarget, -1, -1, 50);
		document.getElementById('gameOverScreen').style.display = 'none';
		document.getElementById('mainMenu').style.display = 'none';
		var fadeTarget2 = document.getElementById("mainGame");
		fadeInEffect(fadeTarget2, -1, -1, 50);
		//document.getElementById('mainGame').style.display = 'block';
		//document.getElementById('waitState').style.display = 'none';
		//document.getElementById("play1").style.display = "none";
		//document.getElementById("information").style.display = "none";

		if(!firstPlayCheck){
			document.getElementById("foundSound").play();
			document.getElementById("foundSound").pause();
			document.getElementById("badSound").play();
			document.getElementById("badSound").pause();
			firstPlayCheck = true;
			//setTimeout(changeScreen,100);
			var mainTheme = document.getElementById("maintheme");
			maintheme.volume = mainVolume;
			maintheme.play();
			maintheme.loop = true;
			setTimeout(function(){
				startup = false;
				newRound();
 			},100);
		}

		//doDebug();
		start = false;
		startup = false;
		paused = false;

	}


	function startReadingLink(){
		var link;
		switch(gameType){
			case "game0":
			link = "https://www.shelfstuff.com/book-shelf/books/the-unteachables/";
			break;
			case "game1":
			link = "https://www.shelfstuff.com/book-shelf/books/new-kid/";
			break;

			case "game2":
			link = "https://www.shelfstuff.com/book-shelf/books/tbh-1-tbh-this-is-so-awkward?id=9780062689900";
			break;
			case "game3":
			link = "https://www.shelfstuff.com/book-shelf/books/popularmmos-presents-a-hole-new-world?id=9780062790873";
			break;

			case "game4":
			link = "https://www.shelfstuff.com/book-shelf/books/bravelands-1-broken-pride?id=9780062642028";
			break;
			default:
			link = "";
			break;
		}
		var win = window.open(link, '_blank');
		win.focus();
	}

	function endDrag(event){
		if(lastTouch === null){
			return;
		}

		disableScolling = false;
		touchPositions[1] = [lastTouch.touches[0].clientX, lastTouch.touches[0].clientY ];
		ballButton = document.elementFromPoint(Math.round(lastTouch.touches[0].clientX), Math.round(lastTouch.touches[0].clientY));
		document.elementFromPoint(Math.round(lastTouch.touches[0].clientX), Math.round(lastTouch.touches[0].clientY)).click();
		lastTouch = null;
	}

	function trackTouch(event){
		if(disableScolling){
			event.preventDefault();
		}
		lastTouch = event;
	}